%ifnarch %{ocaml_native_compiler}
%global debug_package %{nil}
%endif

%global srcname tyxml

Name:           ocaml-tyxml
Version:        4.6.0
Release:        %mkrel 1
Summary:        Type-safe Xml trees in OCaml
License:        LGPLv2 with exception
Group:          Development/OCaml
URL:            https://ocsigen.org/tyxml/
Source0:        https://github.com/ocsigen/tyxml/releases/download/%{version}/%{srcname}-%{version}.tbz

# iOur OCaml is new enough that we do not need the seq shim
Patch:          %{name}-seq.patch

BuildRequires:  ocaml >= 4.04
BuildRequires:  ocaml-alcotest-devel
BuildRequires:  ocaml-dune >= 2.7
BuildRequires:  ocaml-markup-devel >= 0.7.2
BuildRequires:  ocaml-ppxlib-devel >= 0.18
BuildRequires:  ocaml-re-devel >= 1.5.0
BuildRequires:  ocaml-uutf-devel >= 1.0.0

%description
Tyxml is a library that makes it almost impossible for your OCaml programs
to generate wrong XML output, using static typing.  Modules exist for
XHTML1, HTML5 and SVG.  Tyxml also defines pretty printers for these types.


%package      devel
Summary:      Development files for %{name}
Group:        Development/OCaml
Requires:     %{name} = %{version}-%{release}
Requires:       ocaml-re-devel%{?_isa}
Requires:       ocaml-uutf-devel%{?_isa}

%description devel
The %{name}-devel package contains libraries and signature files for
developing applications that use %{name}.

%package        syntax
Summary:        Common layer for the JSX and PPX syntaxes for TyXML

%description    syntax
This package contains common code used by both the JSX and the PPX
syntaxes for TyXML.

%package        syntax-devel
Summary:        Development files for %{name}-syntax
Requires:       %{name}-syntax%{?_isa} = %{version}-%{release}
Requires:       ocaml-ppxlib-devel%{?_isa}
Requires:       ocaml-re-devel%{?_isa}
Requires:       ocaml-uutf-devel%{?_isa}

%description    syntax-devel
The %{name}-syntax-devel package contains libraries and signature files
for developing applications that use %{name}-syntax.

%package        jsx
Summary:        JSX syntax for writing TyXML documents
Requires:       %{name}%{?_isa} = %{version}-%{release}
Requires:       %{name}-syntax%{?_isa} = %{version}-%{release}

%description    jsx
This package enables writing TyXML documents with reasons' JSX syntax,
from textual trees to reactive virtual DOM trees.

  open Tyxml
  let to_ocaml = <a href="ocaml.org"> "OCaml!" </a>;

%package        jsx-devel
Summary:        Development files for %{name}-jsx
Requires:       %{name}-devel%{?_isa} = %{version}-%{release}
Requires:       %{name}-syntax-devel%{?_isa} = %{version}-%{release}
Requires:       %{name}-jsx%{?_isa} = %{version}-%{release}
Requires:       ocaml-ppxlib-devel%{?_isa}

%description    jsx-devel
The %{name}-jsx-devel package contains libraries and signature files for
developing applications that use %{name}-jsx.

%package        ppx
Summary:        PPX for writing TyXML documents with HTML syntax
Requires:       %{name}%{?_isa} = %{version}-%{release}
Requires:       %{name}-syntax%{?_isa} = %{version}-%{release}

%description    ppx
This package contains PPX for writing TyXML documents with HTML syntax.

  open Tyxml
  let%%html to_ocaml = "<a href='ocaml.org'>OCaml!</a>"

The TyXML PPX is compatible with all TyXML instance, from textual trees
to reactive virtual DOM trees.

%package        ppx-devel
Summary:        Development files for %{name}-ppx
Requires:       %{name}-devel%{?_isa} = %{version}-%{release}
Requires:       %{name}-ppx%{?_isa} = %{version}-%{release}
Requires:       %{name}-syntax-devel%{?_isa} = %{version}-%{release}
Requires:       ocaml-markup-devel%{?_isa}
Requires:       ocaml-ppxlib-devel%{?_isa}
Requires:       ocaml-re-devel%{?_isa}

%description    ppx-devel
The %{name}-ppx-devel package contains libraries and signature files for
developing applications that use %{name}-ppx.

%prep
%autosetup -n %{srcname}-%{version} -p1

%build
%dune_build

%install
%dune_install -s

%check
# As of version 4.4.0, the tyxml-jsx tests fail due to lack of the reason
# package.
%dune_check -p tyxml,tyxml-syntax,tyxml-ppx

%files -f .ofiles-tyxml
%doc CHANGES.md README.md
%license LICENSE

%files devel -f .ofiles-tyxml-devel

%files syntax -f .ofiles-tyxml-syntax

%files syntax-devel -f .ofiles-tyxml-syntax-devel

%files jsx -f .ofiles-tyxml-jsx

%files jsx-devel -f .ofiles-tyxml-jsx-devel

%files ppx -f .ofiles-tyxml-ppx

%files ppx-devel -f .ofiles-tyxml-ppx-devel



%changelog
* Thu Jun 19 2025 pterjan <pterjan> 4.6.0-1.mga10
+ Revision: 2192858
- Update to 4.6.0

* Sun Dec 11 2022 pterjan <pterjan> 4.5.0-5.mga9
+ Revision: 1920634
- Rebuild for new ppxlib

* Sat Oct 15 2022 neoclust <neoclust> 4.5.0-4.mga9
+ Revision: 1897018
- Rebuild against new ocaml-base

* Fri May 20 2022 pterjan <pterjan> 4.5.0-3.mga9
+ Revision: 1859456
- Rebuild for OCaml 4.14

* Wed May 18 2022 pterjan <pterjan> 4.5.0-2.mga9
+ Revision: 1858611
- Rebuild for several updated ocaml dependencies

* Fri Oct 15 2021 tv <tv> 4.5.0-1.mga9
+ Revision: 1751555
- Version 4.5.0
- Drop all patches

* Thu Mar 25 2021 tv <tv> 4.4.0-1.mga9
+ Revision: 1709978
- 4.4.0
- Apply upstream merge request to migrate to ppxlib
- Disable doc as it is broken
- Disable failing testsuite

* Sun Jan 10 2021 pterjan <pterjan> 4.3.0-5.mga8
+ Revision: 1670820
- Rebuild to generate ocamlx provides

* Fri Feb 28 2020 umeabot <umeabot> 4.3.0-4.mga8
+ Revision: 1551892
- Rebuild for ocaml 4.10.0 final

* Thu Feb 20 2020 umeabot <umeabot> 4.3.0-3.mga8
+ Revision: 1546054
- Mageia 8 Mass Rebuild

* Fri Jan 31 2020 tv <tv> 4.3.0-2.mga8
+ Revision: 1485691
- fix deps

* Wed Jan 29 2020 tv <tv> 4.3.0-1.mga8
+ Revision: 1485255
- make devel pkg pulls what it needs

* Wed Jan 29 2020 tv <tv> 4.3.0-0.1.mga8
+ Revision: 1485253
- new release + rebuild for ocaml-4.10
- rebuild for new ocaml

* Mon Sep 26 2016 pterjan <pterjan> 3.2.1-6.mga6
+ Revision: 1056448
- Rebuild for fix in ocaml

* Wed Feb 17 2016 daviddavid <daviddavid> 3.2.1-5.mga6
+ Revision: 964475
- fix Requires on ocaml-camlp4-devel

* Fri Feb 12 2016 umeabot <umeabot> 3.2.1-4.mga6
+ Revision: 956672
- Mageia 6 Mass Rebuild

* Wed Oct 15 2014 umeabot <umeabot> 3.2.1-3.mga5
+ Revision: 745659
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 3.2.1-2.mga5
+ Revision: 683119
- Mageia 5 Mass Rebuild

* Tue Sep 09 2014 malo <malo> 3.2.1-1.mga5
+ Revision: 674095
- update to 3.2.1

* Sat Oct 19 2013 umeabot <umeabot> 2.2.0-4.mga4
+ Revision: 535764
- Mageia 4 Mass Rebuild

* Fri Sep 20 2013 malo <malo> 2.2.0-3.mga4
+ Revision: 482476
- add upstream patch for new ocamlnet compatibility

* Sun Jan 13 2013 umeabot <umeabot> 2.2.0-2.mga3
+ Revision: 361672
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Wed Dec 12 2012 malo <malo> 2.2.0-1.mga3
+ Revision: 329919
- new version 2.2.0

* Sat Dec 01 2012 malo <malo> 2.1-5.mga3
+ Revision: 324083
- removed optional ocamlduce dependency
+ fwang <fwang>
- rebuild for new ocaml
+ blue_prawn <blue_prawn>
- rebuild for new ocaml 4.00
- new rpm group for ocaml
- new rpm group for ocaml and documentation

* Thu Jun 28 2012 malo <malo> 2.1-1.mga3
+ Revision: 264737
- update to 2.1

* Sun Apr 22 2012 malo <malo> 2.0.1-4.mga2
+ Revision: 232713
- adding missing requires to camlp4

* Mon Apr 09 2012 malo <malo> 2.0.1-3.mga2
+ Revision: 229855
- adding missing requires to ocaml-ocamlnet

* Fri Feb 17 2012 malo <malo> 2.0.1-2.mga2
+ Revision: 210085
- missing requires to ocamlduce

* Wed Feb 08 2012 malo <malo> 2.0.1-1.mga2
+ Revision: 206236
- imported package ocaml-tyxml

